/**
 * Created by CSL on 2019/12/13.  安徽养护计算程序、基数 等覆盖。
 */

let isAH2019 = true;
function overwriteRationCalcBases() {
    if (typeof rationCalcBases == 'undefined') return;
    for (let key in rationCalcBases) delete rationCalcBases[key];

    rationCalcBases['人工费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, [gljType.LABOUR], priceTypes.ptMarketPrice, isTender);
    };
    rationCalcBases['材料费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, baseMaterialTypes, priceTypes.ptMarketPrice, isTender);
    };
    rationCalcBases['施工机械使用费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, baseMachineTypes, priceTypes.ptMarketPrice, isTender);
    };
    rationCalcBases['施工机械人工费'] = function (node, isTender) {
        return calcTools.machineDetailFee(node, node.data.gljList, [], gljType.MACHINE_LABOUR, isTender);
    };
    rationCalcBases['设备购置费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, [gljType.EQUIPMENT], priceTypes.ptMarketPrice, isTender);
    };

    rationCalcBases['定额人工费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, [gljType.LABOUR], priceTypes.ptBasePrice, isTender);
    };
    rationCalcBases['定额材料费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, baseMaterialTypes, priceTypes.ptBasePrice, isTender);
    };
    rationCalcBases['定额施工机械使用费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, baseMachineTypes, priceTypes.ptBasePrice, isTender);
    };
    rationCalcBases['定额商品砼费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, [gljType.COMMERCIAL_CONCRETE, gljType.COMMERCIAL_MORTAR], priceTypes.ptBasePrice, isTender);
    };
    rationCalcBases['定额设备费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, [gljType.EQUIPMENT], priceTypes.ptBasePrice, isTender);
    };
    rationCalcBases['定额外购砼构件费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, [gljType.PURCHASE_COMPONENT], priceTypes.ptBasePrice, isTender);
    };
    rationCalcBases['定额绿化苗木费'] = function (node, isTender) {
        return calcTools.rationBaseFee(node, [gljType.GREEN_SEEDLING], priceTypes.ptBasePrice, isTender);
    };
};

(function overwriteFeeTypes() {
    if (typeof cpFeeTypes == 'undefined') return;
    cpFeeTypes = [
        { type: 'marketLabour', name: '人工费' },
        { type: 'marketMaterial', name: '材料费' },
        { type: 'marketMachine', name: '施工机械使用费' },
        { type: 'marketMachineLabour', name: '施工机械人工费' },
        { type: 'marketEquipment', name: '设备购置费' },
        { type: 'marketDirect', name: '直接费' },

        { type: 'labour', name: '定额人工费' },
        { type: 'material', name: '定额材料费' },
        { type: 'machine', name: '定额施工机械使用费' },
        { type: 'equipment', name: '定额设备费' },
        { type: 'direct', name: '定额直接费' },

        { type: 'measure', name: '措施费' },
        { type: 'manage', name: '企业管理费' },
        { type: 'force', name: '规费' },
        { type: 'profit', name: '利润' },
        { type: 'tax', name: '税金' },
        { type: 'common', name: '建安费' },
        { type: 'rationCommon', name: '定额建安费' }//,
        // {type: 'safeProduce', name: '安全生产费'}
    ];
})();

// 清单基数
const progression = ['施工场地建设费', '养护单位管理费', '养护项目信息化费', '工程监理费', '设计文件审查费', '前期工作费'];
const deficiency = { '养护项目信息化费': 20000, '工程监理费': 20000, '前期工作费': 30000 };
if (typeof baseFigureMap !== 'undefined') {
    const { fixedFlag } = commonConstants;
    const budgetMap = {
        // 显示：除清单固定类别是“建筑安装工程费”的以外部分可显示。
        '建筑安装工程费': {
            base: 'JZAZGCF',
            fixedFlag: fixedFlag.CONSTRUCTION_INSTALL_FEE,
            filter: [fixedFlag.CONSTRUCTION_INSTALL_FEE],
            pick: false,
        },
        // 显示：仅清单固定类别是“安全生产费”的可显示。
        '建筑安装工程费(不含安全生产费)': {
            base: 'JZAZGCFBHSC',
            fixedFlag: null,
            filter: [fixedFlag.SAFE_COST],
            pick: true
        },
        // 显示：仅清单固定类别是“安全生产费”的可显示。
        '建筑安装工程费(不含设备费)': {
            base: 'JZAZGCFBHSB',
            fixedFlag: fixedFlag.CONSTRUCTION_INSTALL_FEE,
            filter: [fixedFlag.SAFE_COST],
            pick: true
        },
        // 显示：除清单固定类别是“建筑安装工程费”的以外部分可显示。
        '定额建筑安装工程费': {
            base: 'DEJZAZGCF',
            fixedFlag: fixedFlag.CONSTRUCTION_INSTALL_FEE,
            filter: [fixedFlag.CONSTRUCTION_INSTALL_FEE],
            pick: false
        },
        // 显示：仅清单固定类别是“施工场地建设费”的可显示。
        '定额建筑安装工程费(不含定额设备购置费及专项管理费)': {
            base: 'DEJZAZGCFBHSBZXGLF',
            fixedFlag: fixedFlag.CONSTRUCTION_INSTALL_FEE,
            filter: [fixedFlag.CONSTRUCTION_PLANT_COST],
            pick: true,
        },
        // 显示：仅清单固定类别是“养护工程其他费用”的可显示。
        '定额建筑安装工程费(不含专项管理费)': {
            base: 'DEJZAZGCFBHZXGLF',
            fixedFlag: fixedFlag.CONSTRUCTION_INSTALL_FEE,
            filter: [fixedFlag.MAINTENANCE_EXPENSES],
            pick: true,
        },
        // 显示：除清单固定类别是“建筑安装工程费”、“土地使用及拆迁补偿费”的以外部分可显示。
        '土地使用及拆迁补偿费': {
            base: 'TDSYJCQBCF',
            fixedFlag: fixedFlag.LAND_USED_DEMOLITION,
            filter: [fixedFlag.CONSTRUCTION_INSTALL_FEE, fixedFlag.LAND_USED_DEMOLITION],
            pick: false,
        },
        // 显示：除清单固定类别是“建筑安装工程费”、“土地使用及拆迁补偿费”、“工程建设其他费用”的以外部分可显示。
        '工程建设其他费用': {
            base: 'GCJSQTFY',
            fixedFlag: fixedFlag.MAINTENANCE_EXPENSES,
            filter: [fixedFlag.CONSTRUCTION_INSTALL_FEE, fixedFlag.LAND_USED_DEMOLITION, fixedFlag.MAINTENANCE_EXPENSES],
            pick: false,
        },
        // 显示：仅清单固定类别是“施工场地建设费”的可显示。
        '施工场地建设费': {
            isProgressive: true,
            base: 'SGCDJSF',
            fixedFlag: null,
            filter: [fixedFlag.CONSTRUCTION_PLANT_COST],
            pick: true,
        },
        // 显示：仅清单固定类别是“养护工程其他费用”部分可显示。
        '养护单位管理费': {
            isProgressive: true,
            base: 'YHDWGLF',
            fixedFlag: null,
            filter: [fixedFlag.MAINTENANCE_EXPENSES],
            pick: true,
        },
        // 显示：仅清单固定类别是“养护工程其他费用”部分可显示。
        '养护项目信息化费': {
            isProgressive: true,
            deficiency: 20000,
            base: 'YHXMXXHF',
            fixedFlag: null,
            filter: [fixedFlag.MAINTENANCE_EXPENSES],
            pick: true,
        },
        // 显示：仅清单固定类别是“养护工程其他费用”部分可显示。
        '工程监理费': {
            isProgressive: true,
            deficiency: 20000,
            base: 'GCJLF',
            fixedFlag: null,
            filter: [fixedFlag.MAINTENANCE_EXPENSES],
            pick: true,
        },
        // 显示：只有清单固定类别是“养护工程其他费用”部分可显示。
        '设计文件审查费': {
            isProgressive: true,
            base: 'SJWJSCF',
            fixedFlag: null,
            filter: [fixedFlag.MAINTENANCE_EXPENSES],
            pick: true,
        },
        // 显示：只有清单固定类别是“养护工程其他费用”部分可显示。
        '前期工作费': {
            isProgressive: true,
            deficiency: 30000,
            base: 'QQGZF',
            fixedFlag: null,
            filter: [fixedFlag.MAINTENANCE_EXPENSES],
            pick: true,
        },
        // 显示：仅“价差预备费”可显示
        '价差预备费': {
            base: 'JCYBF',
            fixedFlag: null,
            filter: [fixedFlag.SPREAD_BUDGET_FEE],
            pick: true,
        },
    };
    const boqMap = {
        //仅允许用于固定类别是“第100章至700章清单”以外的清单
        '各章清单合计': {
            base: 'GZQDHJ',
            fixedFlag: fixedFlag.ONE_SEVEN_BILLS,
            filter: [fixedFlag.ONE_SEVEN_BILLS],
            pick: false
        },
        //仅允许用于固定类别是“第100章至700章清单”以外的清单
        '专项暂定合计': {
            base: 'ZXZDHJ',
            fixedFlag: null,
            filter: [fixedFlag.ONE_SEVEN_BILLS],
            pick: false
        },
        /*
        *  清单固定行[第100章至700章清单]下的[第100章清单]需要允许清单可使用基数{100章以外合计}
        *  因此{100章以外合计}不设置关联的清单固定行
        * */
        //仅允许用于固定类别为“100章清单”引用
        '100章以外清单合计': {
            base: 'YBZYHQDHJ',
            fixedFlag: null,
            filter: [fixedFlag.ONE_HUNDRED_BILLS],
            pick: true
        }
    };
    baseFigureMap.budget = budgetMap;
    baseFigureMap.boq = boqMap;
}

if (typeof baseFigureTemplate !== 'undefined') {
    const { fixedFlag } = commonConstants;
    baseFigureTemplate.budget = {
        // 建筑安装工程费 算法：取清单固定类别是“建筑安装工程费”的金额。
        JZAZGCF(tender) {
            const feeField = 'common';
            const subFeeField = tender ? 'tenderTotalFee' : 'totalFee';
            return cbTools.getBillsFee(fixedFlag.CONSTRUCTION_INSTALL_FEE, feeField, subFeeField);
        },
        // 建筑安装工程费(不含安全生产费) 算法：取清单固定类别是“建筑安装工程费”的金额，扣除“安全生产费”的金额。
        JZAZGCFBHSC(tender) {
            const fullFeeField = tender ? 'common.tenderTotalFee' : 'common.totalFee';
            const deductFlags = [fixedFlag.SAFE_COST];
            return cbTools.getFeeWithDeduction(fixedFlag.CONSTRUCTION_INSTALL_FEE, deductFlags, fullFeeField).toDecimal(decimalObj.bills.totalPrice);
        },
        // 建筑安装工程费(不含设备费) 算法：取清单固定类别是“建筑安装工程费”的金额，扣除设备的金额。
        JZAZGCFBHSB(tender) {
            const fullFeeField = tender ? 'common.tenderTotalFee' : 'common.totalFee';
            const deductFlags = [fixedFlag.EQUIPMENT_ACQUISITION_FEE];
            return cbTools.getFeeWithDeduction(fixedFlag.CONSTRUCTION_INSTALL_FEE, deductFlags, fullFeeField).toDecimal(decimalObj.bills.totalPrice);
        },
        // 定额建筑安装工程费 算法：取清单固定类别是“建筑安装工程费”的定额建安费。
        DEJZAZGCF(tender) {
            const feeField = 'rationCommon';
            const subFeeField = tender ? 'tenderTotalFee' : 'totalFee';
            return cbTools.getBillsFee(fixedFlag.CONSTRUCTION_INSTALL_FEE, feeField, subFeeField);
        },
        // 定额建筑安装工程费(不含定额设备购置费及专项管理费) 算法：取清单固定类别是“建筑安装工程费”的“定额建安费”，扣除设备的“定额设备费”，扣除“专项费用”的“定额建安费”。
        DEJZAZGCFBHSBZXGLF(tender) {
            const fullFeeField = tender ? 'rationCommon.tenderTotalFee' : 'rationCommon.totalFee';
            const deductFlags = [fixedFlag.EQUIPMENT_ACQUISITION_FEE, fixedFlag.SAFE_COST];
            //建安费扣除设备费
            return cbTools.getFeeWithDeduction(fixedFlag.CONSTRUCTION_INSTALL_FEE, deductFlags, fullFeeField).toDecimal(decimalObj.bills.totalPrice);
        },
        // 定额建筑安装工程费(不含专项管理费) 算法：取清单固定类别是“建筑安装工程费”的“定额建安费”，扣除“专项费用”的“定额建安费”。
        DEJZAZGCFBHZXGLF(tender) {
            const fullFeeField = tender ? 'rationCommon.tenderTotalFee' : 'rationCommon.totalFee';
            const deductFlags = [fixedFlag.SAFE_COST];
            //建安费扣除设备费
            return cbTools.getFeeWithDeduction(fixedFlag.CONSTRUCTION_INSTALL_FEE, deductFlags, fullFeeField).toDecimal(decimalObj.bills.totalPrice);
        },
        // 土地使用及拆迁补偿费 算法：取清单固定类别是“土地使用及拆迁补偿费”的金额。
        TDSYJCQBCF(tender) {
            const feeField = 'common';
            const subFeeField = tender ? 'tenderTotalFee' : 'totalFee';
            return cbTools.getBillsFee(fixedFlag.LAND_USED_DEMOLITION, feeField, subFeeField);
        },
        // 工程建设其他费用 算法：取清单固定类别是“养护工程其他费用”的金额。
        GCJSQTFY(tender) {
            const feeField = 'common';
            const subFeeField = tender ? 'tenderTotalFee' : 'totalFee';
            return cbTools.getBillsFee(fixedFlag.MAINTENANCE_EXPENSES, feeField, subFeeField);
        },
        // 施工场地建设费 算法：以{定额建筑安装工程费(不含定额设备购置费及专项管理费) }为基数，采用累进办法计算。
        SGCDJSF(tender) {
            const baseFee = this['DEJZAZGCFBHSBZXGLF'](tender);
            if (!tender) {
                calcBase.baseProgressiveFee = baseFee;
            }
            return calculateUtil.getProgressiveFee(baseFee, '施工场地建设费', projectObj.project.property.progressiveInterval, decimalObj.bills.totalPrice, deficiency);
        },
        // 养护单位管理费 算法：以{定额建筑安装工程费(不含专项管理费) }为基数，采用累进办法计算。
        YHDWGLF(tender) {
            const baseFee = this['DEJZAZGCFBHZXGLF'](tender);
            if (!tender) {
                calcBase.baseProgressiveFee = baseFee;
            }
            return calculateUtil.getProgressiveFee(baseFee, '养护单位管理费', projectObj.project.property.progressiveInterval, decimalObj.bills.totalPrice, deficiency);
        },
        // 养护项目信息化费 算法：以{定额建筑安装工程费}为基数，采用累进办法计算。(不足20000元时按20000元计算)
        YHXMXXHF(tender) {
            const baseFee = this['DEJZAZGCF'](tender);
            if (!tender) {
                calcBase.baseProgressiveFee = baseFee;
            }
            return calculateUtil.getProgressiveFee(baseFee, '养护项目信息化费', projectObj.project.property.progressiveInterval, decimalObj.bills.totalPrice, deficiency);
        },
        // 工程监理费 算法：以{定额建筑安装工程费(不含专项管理费) }为基数，采用累进办法计算。(不足20000元时按20000元计算)
        GCJLF(tender) {
            const baseFee = this['DEJZAZGCFBHZXGLF'](tender);
            if (!tender) {
                calcBase.baseProgressiveFee = baseFee;
            }
            return calculateUtil.getProgressiveFee(baseFee, '工程监理费', projectObj.project.property.progressiveInterval, decimalObj.bills.totalPrice, deficiency);
        },
        // 设计文件审查费 算法：以{定额建筑安装工程费(不含专项管理费) }为基数，采用累进办法计算。
        SJWJSCF(tender) {
            const baseFee = this['DEJZAZGCFBHZXGLF'](tender);
            if (!tender) {
                calcBase.baseProgressiveFee = baseFee;
            }
            return calculateUtil.getProgressiveFee(baseFee, '设计文件审查费', projectObj.project.property.progressiveInterval, decimalObj.bills.totalPrice, deficiency);
        },
        // 前期工作费 算法：以{定额建筑安装工程费(不含专项管理费) }为基数，采用累进办法计算。(不足30000元时按30000元计算)
        QQGZF(tender) {
            const baseFee = this['DEJZAZGCFBHZXGLF'](tender);
            if (!tender) {
                calcBase.baseProgressiveFee = baseFee;
            }
            return calculateUtil.getProgressiveFee(baseFee, '前期工作费', projectObj.project.property.progressiveInterval, decimalObj.bills.totalPrice, deficiency);
        },
        /*  价差预备费 算法：以建筑安装工程费为基数，按设计文件编制年始至养护项目工程竣工年终的年数和年工程造价增涨率计算。
            价差预备费 P * [(1+i)^(n-1) -1]
            P——建筑安装工程费总额（元）；
            i——年工程造价增涨率（%）；
            n——设计文件编制年至养护项目开工年+养护项目建设期限（年）。
        */
        JCYBF(tender) {
            //建筑安装工程费作为基数
            const installFee = this['JZAZGCF'](tender);
            //年造价增涨
            const costGrowthRate = calcBase.project.property.costGrowthRate
                ? calcBase.project.property.costGrowthRate
                : 0;
            //增涨计费年限
            const growthPeriod = projectObj.project.property.growthPeriod
                ? calcBase.project.property.growthPeriod
                : 0;
            //= P * [(1+i)^(n-1) -1]
            return (installFee * (Math.pow(1 + costGrowthRate, growthPeriod - 1) - 1)).toDecimal(decimalObj.bills.totalPrice);
        }

    };

    baseFigureTemplate.boq = {
        //{各章清单合计}
        // 取清单固定类别是“第100章至700章清单”的金额
        'GZQDHJ': function (tender) {
            let feeField = 'common',
                subFeeField = tender ? 'tenderTotalFee' : 'totalFee';
            return cbTools.getBillsFee(calcBase.fixedFlag.ONE_SEVEN_BILLS, feeField, subFeeField);
        },
        //{专项暂定合计}
        // 汇总专项暂定列有值的清单的金额
        'ZXZDHJ': function (tender) {
            let rst = 0,
                feeField = 'common',
                subFeeField = tender ? 'tenderTotalFee' : 'totalFee';
            let billsData = calcBase.project.Bills.datas,
                filterData = billsData.filter(function (data) {
                    return data.specialProvisional;
                });
            for (let data of filterData) {
                if (cbTools.isUnDef(data.feesIndex) || _.isEmpty(data.feesIndex) ||
                    cbTools.isUnDef(data.feesIndex[feeField]) || cbTools.isUnDef(data.feesIndex[feeField][subFeeField])) {
                    continue;
                }
                rst += data.feesIndex[feeField][subFeeField];
            }
            return rst.toDecimal(decimalObj.bills.totalPrice);
        },
        //{100章以外清单合计}
        // 取清单固定清单[第100章至700章清单]的金额，但扣除清单100章下的金额。
        // 如果是固定清单[第100章至700章清单]下100章以外清单引用此基数，要排除自身(目前只允许100章的清单使用，所以暂时不需要此判断)
        'YBZYHQDHJ': function (tender) {
            let oneToSeven = cbTools.findNodeByFlag(fixedFlag.ONE_SEVEN_BILLS);
            if (!oneToSeven) {
                return 0;
            }
            //100-700章固定节点的所有子节点
            let allChildren = [];
            function getChildren(nodes) {
                allChildren = allChildren.concat(nodes);
                for (let node of nodes) {
                    if (node.children.length > 0) {
                        getChildren(node.children);
                    }
                }
            }
            getChildren(oneToSeven.children);
            //扣除的节点：100章的节点[100-200)
            let deductNodes = allChildren.filter(cbTools.withingOneHundred);
            //计算金额
            let fullFeeField = tender ? 'common.tenderTotalFee' : 'common.totalFee';
            return projectObj.project.calcProgram.getTotalFee([oneToSeven], deductNodes, fullFeeField).toDecimal(decimalObj.bills.totalPrice);
        }
    };
}

// 安徽养护在新建分段的时候需要隐藏养护类别和费用标准
if (typeof $ !== 'undefined') { // 后端也有引用这个文件，后端引用时$没有定义会报错
    $(document).ready(function () {
        $('#tender-engineering-group').hide();
        $('#tender-feeStandard-group').hide();
    });
}

if (typeof module !== 'undefined') {
    module.exports = {
        progression,
        deficiency
    };
}